+++
date = "2019-09-03"
weight = 100

title = "Roadmap"

aliases = [
    "/old-wiki/Roadmap"
]
+++

This is a rough list of areas which have planned work for the upcoming
future. This is not a full list and is intended to be used only as a
rough guide. Discussion of future development should happen on the
[devel@lists.apertis.org mailing
list](https://lists.apertis.org/listinfo/devel).

## 2019

**SDK**

  - Support artifacts for NFS boot as part of the official release
  - Cross-building: Deliver a compiler toolchain tarball
  - Implementation of solution for maintaining workspace across SDK
    update

**System Update**

  - OTA system updates (hosting and device agent)
  - Add signature mechanism to upstream OSTree avoiding GPLv3
    dependencies
  - System update authentication checks (signatures)
  - Deployment management proof-of-concept: Infrastructure
  - Deployment management proof-of-concept: Integration with image build
  - Deployment management proof-of-concept: Apertis hawkBit Agent

**Infrastructure**

  - Initial investigation on using GitLab CI to submit packages to OBS
  - Implement the improved branching automation for OBS
  - Improved QA infrastructure: manual test results

**Concepts**

  - Concept document for the next-generation Apertis application
    framework
  - Concept for hosting the whole build infrastructure on Intel
    x86-64-only providers
  - Concept for secure boot
  - Concept for improving the branching automation

**Documentation**

  - Design document for OTA system updates
  - Developer documentation for sysroot and devroot usage
  - Document how to track DUT-local resources consumption during tests

## 2018 H2 (second half)

**SDK**

  - Introduce support for cross-build from the SDK
  - Implementation of Sensors & Actuators API improvements

**AppFramework**

  - Gap analysis on AppFramework features (Appbundle de-/installation,
    start/stop, agent support, inter-app communication, etc.)

**System Update**

  - Improve system update & rollback functionality based on OSTree

**Concepts**

  - Create concept document for Apertis product line approach
  - Create concept document for source code license checking
  - Create concept document for cross-building from the SDK

**Documentation**

  - Create product description document for Apertis
  - Create quick guide on LAVA dispatcher setup
